C-----------------------------------------------------------------------
      SUBROUTINE BAWRITE(LU,IB,NB,KA,A)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C
C SUBPROGRAM: BAWRITE        BYTE-ADDRESSABLE WRITE
C   PRGMMR: IREDELL          ORG: W/NMC23     DATE: 94-04-01
C
C ABSTRACT: WRITE A GIVEN NUMBER OF BYTES TO AN UNBLOCKED FILE,
C   SKIPPING A GIVEN NUMBER OF BYTES.  THE FILE MUST BE OPENED
C   USING BAOPEN.
C
C PROGRAM HISTORY LOG:
C   94-04-01  IREDELL
C   96-10-01  IREDELL     STANDARD F77 VERSION
C
C USAGE:    CALL BAWRITE(LU,IB,NB,KA,A)
C   INPUT ARGUMENTS:
C     LU           INTEGER UNIT TO WRITE
C     IB           INTEGER NUMBER OF BYTES TO SKIP
C     NB           INTEGER NUMBER OF BYTES TO WRITE
C     A            CHARACTER*1 (NB) BUFFER READ
C   OUTPUT ARGUMENTS:
C     KA           INTEGER NUMBER OF BYTES ACTUALLY WRITTEN
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 77
C
C$$$
      CHARACTER A(NB)
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      KA=0
      IF(IB.LT.0) THEN
        INQUIRE(LU,NEXTREC=KR,IOSTAT=IOS)
        IF(IOS.NE.0) RETURN
      ELSE
        KR=IB+1
      ENDIF
      DO KB=1,NB
        WRITE(LU,REC=KR,IOSTAT=IOS) A(KA+1)
        IF(IOS.NE.0) RETURN
        KA=KA+1
        KR=KR+1
      ENDDO
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      RETURN
      END
